{Exemple de programmation de l'effet geiss en Turbo Pascal 7
 sous Dos

 Par Plouf (plouf@win.be ou theplouf@yahoo.com)

 Ce programme est uniquement conu dans un rle didactique,
 de ce fait il n'est optimis en aucune mesure. J'ai galement
 tent de le faire aussi lisible que possible, en utilisant
 des typecast pour bien montrer dans quel tableau je travaillais
 et quel lment je prenais.

 Cet effet ne se passe que sur la moiti de l'cran, en effet
 l'effet geiss demande une table de deux octets par pixel (du
 moins en 320x200, et encore plus dans les autres rsolutions),
 ce qui en plein cran aurait occasion une table de 128k,
 irralisable sous DOS en mode rel. Je me suis donc limit
  une moiti d'cran, ce qui ne demande qu'une table de
 64000octets.

 Tous commentaires ou questions bienvenus.
}


program geiss;
uses crt;

type ttable=array[0..31999] of word;
type tscreen=array[0..31999] of byte;

var table,buffer1,buffer2,temp:pointer;

var r,x,y,nx,ny:integer;
    mix,adr:word;
    b,newcol:byte;

procedure setcolor(c,r,v,b:byte);assembler;
asm
  mov dx, 3c8h
  mov al, c
  out dx, al
  inc dx
  mov al, r
  out dx, al
  mov al, v
  out dx, al
  mov al, b
  out dx, al
end;

procedure pset(x,y:integer;c:byte);
begin
  tscreen(buffer1^)[x+y*320]:=c;
end;

begin
  asm
    mov ax, 13h
    int 10h
  end;

  for b:=0 to 255 do setcolor(b,b div 4,b div 4,b div 4);

  getmem(table,64000);
  getmem(buffer1,32000);
  getmem(buffer2,32000);

  (*une table qui prend le pixel un rien plus au centre que le
    pixel dont on parle, histoire d'avoir un effet agrandissant
    ou tunel*)
  for x:=0 to 319 do begin
    for y:=0 to 99 do begin
      r:=random(3);dec(r);
      nx:=round((x-159)*9/10+159+r/5);
      ny:=round((y-49)*9/10+49+r/5);
      ttable(table^)[x+y*320]:=nx+ny*320;
    end;
  end;

  fillchar(buffer1^,32000,0);
  fillchar(buffer2^,32000,0);

  x:=159;y:=49;
  nx:=1;ny:=1;

  repeat
    (*affichons un pixel qui se balade sur l'cran*)
    inc(x,nx);
    inc(y,ny);
    if (x>300) or (x<20) then nx:=-nx;
    if (y>80) or (y<20) then ny:=-ny;
    pset(x+0,y+0,255);
    pset(x+1,y+0,255);
    pset(x+1,y+1,255);
    pset(x+0,y+1,255);

    (*l'effet geiss en lui-mme*)
    for adr:=320 to 320*98-1 do begin
      (*autour de quel pixel on va rechercher nos infos*)
      mix:=ttable(table^)[adr];
      (*on mixe avec les couleurs de ce pixel*)
      newcol:=(
        tscreen(buffer1^)[mix]+
        tscreen(buffer1^)[mix-1]+
        tscreen(buffer1^)[mix-320]+
        tscreen(buffer1^)[mix+321]) shr 2;
      (*on envoie le rsultat dans notre buffer de destination*)
      tscreen(buffer2^)[adr]:=newcol;
    end;

    (*copions vers l'cran*)
    move(buffer2^,ptr($a000,0)^,32000);

    (*un petit swap des buffers*)
    temp:=buffer1;
    buffer1:=buffer2;
    buffer2:=temp;
  until keypressed;

  freemem(buffer1,32000);
  freemem(buffer2,32000);
  freemem(table,64000);

  asm
    mov ax, 03h
    int 10h
  end;
end.